﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.Serialization.Json;
using System.IO;
using System.Text.RegularExpressions;
namespace ControllersAndActions.Uitity
{
   public class JsonHelper
    {
       /// <summary>
       /// 把对象序列化为json
       /// </summary>
       /// <typeparam name="T">对象类型</typeparam>
       /// <param name="t"></param>
       /// <returns></returns>
       public static string JsonSerializer<T>(T t)
       {
           DataContractJsonSerializer ser = new DataContractJsonSerializer(typeof(T));
           MemoryStream ms = new MemoryStream();
           ser.WriteObject(ms,t);
           string jsonString = Encoding.UTF8.GetString(ms.ToArray());
           ms.Close();
           string p = @"\\/Date\((\d+)\+\d+\)\\/";
           MatchEvaluator matchEvaluator = new MatchEvaluator(ConvertJsonDateToDateString);
           Regex reg = new Regex(p);
           jsonString = reg.Replace(jsonString, matchEvaluator);
           return jsonString;
       }

       /// <summary>
       /// 把json序列化为对象
       /// </summary>
       /// <typeparam name="T"></typeparam>
       /// <param name="jsonString"></param>
       /// <returns></returns>
       public static T JsonDeserialize<T>(string jsonString)
       {
           string p = @"\d{4}-\d{2}-\d{2}\s\d{2}:\d{2}:\d{2}";
           MatchEvaluator matchEvaluator = new MatchEvaluator(ConvertDateStringToJsonDate);
           Regex reg = new Regex(p);
           jsonString = reg.Replace(jsonString, matchEvaluator);
           DataContractJsonSerializer ser = new DataContractJsonSerializer(typeof(T));
           MemoryStream ms = new MemoryStream(Encoding.UTF8.GetBytes(jsonString));
           T obj = (T)ser.ReadObject(ms);
           return obj;
       }

       /// <summary>
       /// 将时间字符串转化为你json时间
       /// </summary>
       /// <param name="m"></param>
       /// <returns></returns>
       private static string ConvertDateStringToJsonDate(Match m)
       {
           string result = string.Empty;
           DateTime dt = DateTime.Parse(m.Groups[0].Value);
           dt = dt.ToUniversalTime();
           TimeSpan ts = dt - DateTime.Parse("1900-01-11");
           result = string.Format("\\/Date({0}+0800)\\/", ts.TotalMilliseconds);
           return result;
       }

       private static string ConvertJsonDateToDateString(Match m)
       {
           string result = string.Empty;
           DateTime dt = new DateTime(1970,1,1);
           dt=dt.AddMilliseconds(long.Parse(m.Groups[1].Value));
           dt = dt.ToLocalTime();
           result = dt.ToString("yyyy-MM-dd HH:mm:ss");
           return result;
       }
    }
}
